/*
   Move the definition of the Comparator into an
   anonymous lambda expression at the call to sort().
*/
import java.util.*;

public class ComparatorTester5
{
   public static void main(String[] args)
   {
      ArrayList<Country> countries = new ArrayList<Country>();
      countries.add(new Country("Uruguay",  176220, 3.4));
      countries.add(new Country("Thailand", 514000, 67));
      countries.add(new Country("Belgium",   30528, 11));
      countries.add(new Country("Zaire",   2345410, 46.5));
      countries.add(new Country("Belize",    22966, 0.334));

      // NOTE: This IS NOT really Java! (At least not yet. Maybe in Java 8.)
      // Call the sort() method and pass it an anonymous lambda expression
      // that implements the one method from the Comparator interface.
      Collections.sort( countries, (c1, c2) -> c1.getName().compareTo(c2.getName()) );

      // Now the ArrayList is sorted by name.
      for (Country c : countries)
        System.out.println( c );
      System.out.println();
   }
}