(define countries
   '(("Uruguay"  176220   3.4)
     ("Thailand" 513000    67)
     ("Belgium"   30528    11)
     ("Zaire"   2345410  46.5) 
     ("Belize"    22966  0.334)))

(define mySort
  (lambda (lst cmp)  ; cmp is a function parameter
    (letrec
        ((insert
          (lambda (x lst)  ; nested function
            (cond
              ((null? lst) (cons x '()))
              ((cmp x (car lst)) (cons x lst)) ; cmp is a non-local reference
              (else                            ; that is lexically scoped
               (cons (car lst) (insert x (cdr lst)))))))
         (sort
          (lambda (lst)                ; another nested function
            (cond ((null? lst) '())
            (else (insert (car lst) (sort (cdr lst))))))))
      (sort lst))))

(define makeCmpByArea
  (lambda (fn)                              ; fn is a function parameter
    (lambda (c1 c2)                         ; makeCmpByArea has a function return value
      (fn (car (cdr c1)) (car (cdr c2)))))) ; fn is a non-local reference

(define makeCmpByPopulation
  (lambda (fn)                       ; fn is a function parameter
    (lambda (c1 c2)                  ; a function return value
       (fn (caddr c1) (caddr c2))))) ; fn is a non-local reference

(mySort countries (makeCmpByArea <))
(mySort countries (makeCmpByArea >))
(mySort countries (makeCmpByPopulation <))
(mySort countries (makeCmpByPopulation >))